Attribute VB_Name = "basFeiertage"
'Option Explicit
'Compare Database   'Verwenden der Datenbank-Sortierreihenfolge beim Vergleich von Zeichenfolgen.
'---------------------------------------------------------------------------
'Function PRV-IsFeiertag() emittelt zu beliebigem Datum zwischen 1900 und 2099
'ob der betreffende Tag ein Feiertag ist
'Syntax: PRV_Feiertag(Testdatum, Bundesland)
'Aufruf: If PRV_Feiertag(#30.03.97#, 1) = True Then........
'
'Parameter fr Bundesland:
    ' 1-nur Feiertage Gesamtes Bundesgebiet
    ' 2-Baden Wthemberg
    ' 3-Bayern
    ' 4-Berlin
    ' 5-Brandenburg
    ' 6-Bremen
    ' 7-Hamburg
    ' 8-Hessen
    ' 9-Mecklenburg-Vorp.
    '10-Niedersachsen
    '11-Nordrhein-Westf.
    '12-Rheinland-Pfalz
    '13-Saarland
    '14-Sachsen
    '15-Sachsen-Anhalt
    '16-Schleswig-Holstein
    '17-Thringen


'Dim dat As String, fwn As String, dfnw As String
'Dim prv_Bettag As Date


Function PRV_Allerheiligen(Jahreszahl As Variant)
'Berechnet das Datum fr Heilige Drei Knige
'Fester Feiertag am 1. November
    PRV_Allerheiligen = DateSerial(Jahreszahl, 11, 1)
End Function

Function prv_Bettag(Jahreszahl As Variant)
'Berechnet das Datum fr Bu-und Bettag
'Beweglicher Feiertag, 3.Mittwoch im November
    dat = "1/11/" & Jahreszahl
    fwn = DatePart("ww", dat)
    dfnw = DatePart("w", dat)
    dif = dfnw - 4
    prv_Bettag = CVDate(dat) - dif + 21
End Function

Function PRV_ChrHimmelfahrt(Jahreszahl As Variant)
'Berechnet das Datum fr Christi Himmelfahrt
'Beweglicher Feiertag 39 Tage nach Ostern
    PRV_ChrHimmelfahrt = PRV_Ostern(Jahreszahl) + 39
End Function

Function PRV_DreiKnig(Jahreszahl As Variant)
'Berechnet das Datum fr Heilige Drei Knige
'Fester Feiertag am 6. Januar
    PRV_DreiKnig = DateSerial(Jahreszahl, 1, 6)
End Function

Function PRV_DtEinheit(Jahreszahl As Variant)
'Berechnet das Datum fr den Tag d. dt. Einheit
'Fester Feiertag am 3.Oktober
    PRV_DtEinheit = DateSerial(Jahreszahl, 10, 3)
End Function

Function PRV_Fronleichnam(Jahreszahl As Variant)
'Berechnet das Datum fr Fronleichnam
'Beweglicher Feiertag, 60 Tage nach Ostern
    PRV_Fronleichnam = PRV_Ostern(Jahreszahl) + 60
End Function

Function PRV_IsFeiertag(TestDatum As Variant, Bundesland As Integer) As Integer
On Error GoTo Err_PRV_IsFeiertag

    PRV_IsFeiertag = False
    JahrDatum = Year(TestDatum)
    If TestDatum = PRV_Ostern(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Neujahr(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Ostermontag(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Pfingstmontag(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Pfingstsonntag(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_ChrHimmelfahrt(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_DtEinheit(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Karfreitag(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Maifeiertag(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Weihnachten1(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    ElseIf TestDatum = PRV_Weihnachten2(JahrDatum) Then
        PRV_IsFeiertag = True
        Exit Function
    End If
    Select Case Bundesland
        Case 2
            If TestDatum = PRV_DreiKnig(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_Fronleichnam(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_Allerheiligen(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 3
            If TestDatum = PRV_DreiKnig(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_Fronleichnam(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_Allerheiligen(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_MHimmelfahrt(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 5
            If TestDatum = PRV_Reformationstag(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 8
            If TestDatum = PRV_Fronleichnam(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 9
            If TestDatum = PRV_Reformationstag(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 11, 12
            If TestDatum = PRV_Fronleichnam(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_Allerheiligen(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 13
            If TestDatum = PRV_Fronleichnam(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_Allerheiligen(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_MHimmelfahrt(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 14
            If TestDatum = PRV_Reformationstag(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = prv_Bettag(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 15
            If TestDatum = PRV_DreiKnig(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            ElseIf TestDatum = PRV_Reformationstag(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
        Case 17
            If TestDatum = PRV_Reformationstag(JahrDatum) Then
                PRV_IsFeiertag = True
                Exit Function
            End If
    End Select
Exit_PRV_IsFeiertag:
    Exit Function
Err_PRV_IsFeiertag:
    MsgBox Error$
    PRV_IsFeiertag = False
    Resume Err_PRV_IsFeiertag
End Function

Function PRV_Karfreitag(Jahreszahl As Variant)
'Berechnet das Datum fr den Karfreitag
'Beweglicher Feiertag, 2 Tage vor Ostern
    PRV_Karfreitag = PRV_Ostern(Jahreszahl) - 2
End Function

Function PRV_Maifeiertag(Jahreszahl As Variant)
'Berechnet das Datum fr den Maifeiertag
'Fester Feiertag am 1. Mai
    PRV_Maifeiertag = DateSerial(Jahreszahl, 5, 1)
End Function

Function PRV_MHimmelfahrt(Jahreszahl As Variant)
'Berechnet das Datum fr Mari Himmelfahrt
'Fester Feiertag am 15. August
    PRV_MHimmelfahrt = DateSerial(Jahreszahl, 8, 15)
End Function

Function PRV_Neujahr(Jahreszahl As Variant)
'Berechnet das Datum fr das Neujahrsfest
'Fester Feiertag am 1. Januar
    PRV_Neujahr = DateSerial(Jahreszahl, 1, 1)
End Function

Function PRV_Ostermontag(Jahreszahl As Variant)
'Berechnet das Datum fr den Ostermontag
'Abhngig von Ostern
    PRV_Ostermontag = PRV_Ostern(Jahreszahl) + 1
End Function

Function PRV_Ostern(Jahreszahl As Variant)
'Berechnet das Datum fr das Osterfest
'Beweglicher Feiertag, abhngig vom 1. Frhlingsvollmond
'Berechnet mit Hilfe des Algorithmus von Gau

Dim a, b, c, d, e, Tageszahl As Integer

a = Jahreszahl Mod 19                   'Gau'sche Formel
b = Jahreszahl Mod 4
c = Jahreszahl Mod 7
d = (19 * a + 24) Mod 30            'M = 24
e = (2 * b + 4 * c + 6 * d + 5) Mod 7   'N = 5
Tageszahl = 22 + d + e          'Ermittelt den Tag

If Tageszahl > 31 Then          'Bestimmt, ob Mrz oder April
    Tageszahl = Tageszahl - 31      'Wenn April, dann werden 31 Tage abgezogen
    If Tageszahl = 26 Then Tageszahl = 19
    '1.Ausnahme: Wenn Ostern = 26.4. dann immer 19.4.!
    
    If (Tageszahl = 25 And d = 28 And a > 10) Then Tageszahl = 18
    '2.Ausnahme

    PRV_Ostern = DateSerial(Jahreszahl, 4, Tageszahl)   'Ostern fllt in den April
Else
    PRV_Ostern = DateSerial(Jahreszahl, 3, Tageszahl)   'Ostern fllt in den Mrz
End If
End Function

Function PRV_Pfingstmontag(Jahreszahl As Variant)
'Berechnet das Datum fr den Pfingstmontag
'Beweglicher Feiertag, 50 Tage nach Ostern
    PRV_Pfingstmontag = PRV_Ostern(Jahreszahl) + 50
End Function

Function PRV_Pfingstsonntag(Jahreszahl As Variant)
'Berechnet das Datum fr den Pfingstsonntag
'Beweglicher Feiertag, 50 Tage nach Ostern
    PRV_Pfingstsonntag = PRV_Ostern(Jahreszahl) + 49
End Function

Function PRV_Reformationstag(Jahreszahl As Variant)
'Berechnet das Datum fr den Reformationstag
'Fester Feiertag am 31.Oktober
    PRV_Reformationstag = DateSerial(Jahreszahl, 10, 31)
End Function

Function PRV_Weihnachten1(Jahreszahl As Variant)
'Berechnet das Datum fr den 1. Weihnachtstag
'Fester Feiertag am 25. Dezember
    PRV_Weihnachten1 = DateSerial(Jahreszahl, 12, 25)
End Function

Function PRV_Weihnachten2(Jahreszahl As Variant)
'Berechnet das Datum fr den 2. Weihnachtstag
'Fester Feiertag am 26. Dezember
    PRV_Weihnachten2 = DateSerial(Jahreszahl, 12, 26)
End Function


