Attribute VB_Name = "basGDI"
Option Explicit

Sub BltTransparent(ddc As Long, DstX As Long, DstY As Long, DstW As Long, DstH As Long, SrcDC As Long, SrcLeft As Long, SrcTop As Long, TransColor As Long)
  'DstDC- Device context into which image must be
  'drawn transparently

  'OutDstDC- Device context into image is actually drawn,
  'even though it is made transparent in terms of DstDC

  'Src- Device context of source to be made transparent
  'in color TransColor

  'SrcRect- Rectangular region within SrcDC to be made
  'transparent in terms of DstDC, and drawn to OutDstDC

  'DstX, DstY - Coordinates in OutDstDC (and DstDC)
  'where the transparent bitmap must go. In most
  'cases, OutDstDC and DstDC will be the same
   
  Dim OutDstDC As Long, DstDC As Long
  Dim nRet As Long, w As Long, h As Long
  Dim MonoMaskDC As Long, hMonoMask As Long
  Dim MonoInvDC As Long, hMonoInv As Long
  Dim ResultDstDC As Long, hResultDst As Long
  Dim ResultSrcDC As Long, hResultSrc As Long
  Dim hPrevMask As Long, hPrevInv As Long
  Dim hPrevSrc As Long, hPrevDst As Long

  OutDstDC = ddc
  DstDC = ddc
  
  'W = SrcRect.Right - SrcRect.Left '+ 1
  'H = SrcRect.bottom - SrcRect.Top '+ 1
  w = DstW
  h = DstH
   
 'create monochrome mask and inverse masks
  MonoMaskDC = CreateCompatibleDC(DstDC)
  MonoInvDC = CreateCompatibleDC(DstDC)
  hMonoMask = CreateBitmap(w, h, 1, 1, ByVal 0&)
  hMonoInv = CreateBitmap(w, h, 1, 1, ByVal 0&)
  hPrevMask = SelectObject(MonoMaskDC, hMonoMask)
  hPrevInv = SelectObject(MonoInvDC, hMonoInv)
   
 'create keeper DCs and bitmaps
  ResultDstDC = CreateCompatibleDC(DstDC)
  ResultSrcDC = CreateCompatibleDC(DstDC)
  hResultDst = CreateCompatibleBitmap(DstDC, w, h)
  hResultSrc = CreateCompatibleBitmap(DstDC, w, h)
  hPrevDst = SelectObject(ResultDstDC, hResultDst)
  hPrevSrc = SelectObject(ResultSrcDC, hResultSrc)
   
'copy src to monochrome mask
  Dim OldBC As Long
  OldBC = SetBkColor(SrcDC, TransColor)
  nRet = BitBlt(MonoMaskDC, 0, 0, w, h, SrcDC, _
                SrcLeft, SrcTop, vbSrcCopy)
  TransColor = SetBkColor(SrcDC, OldBC)
   
 'create inverse of mask
  nRet = BitBlt(MonoInvDC, 0, 0, w, h, _
                MonoMaskDC, 0, 0, vbNotSrcCopy)
   
 'get background
  nRet = BitBlt(ResultDstDC, 0, 0, w, h, _
                DstDC, DstX, DstY, vbSrcCopy)
   
 'AND with Monochrome mask
  nRet = BitBlt(ResultDstDC, 0, 0, w, h, _
                MonoMaskDC, 0, 0, vbSrcAnd)
   
 'get overlapper
  nRet = BitBlt(ResultSrcDC, 0, 0, w, h, SrcDC, _
                SrcLeft, SrcTop, vbSrcCopy)
   
 'AND with inverse monochrome mask
  nRet = BitBlt(ResultSrcDC, 0, 0, w, h, _
                MonoInvDC, 0, 0, vbSrcAnd)
   
'XOR these two
  nRet = BitBlt(ResultDstDC, 0, 0, w, h, _
                ResultSrcDC, 0, 0, vbSrcInvert)
   
 'output results
  nRet = BitBlt(OutDstDC, DstX, DstY, w, h, _
                ResultDstDC, 0, 0, vbSrcCopy)
   
 'clean up
  hMonoMask = SelectObject(MonoMaskDC, hPrevMask)
  DeleteObject hMonoMask

  hMonoInv = SelectObject(MonoInvDC, hPrevInv)
  DeleteObject hMonoInv

  hResultDst = SelectObject(ResultDstDC, hPrevDst)
  DeleteObject hResultDst

  hResultSrc = SelectObject(ResultSrcDC, hPrevSrc)
  DeleteObject hResultSrc

  DeleteDC MonoMaskDC
  DeleteDC MonoInvDC
  DeleteDC ResultDstDC
  DeleteDC ResultSrcDC

End Sub








