Attribute VB_Name = "basRAS"
Option Explicit

Private Type RASENTRYNAME95
    dwSize As Long
    szEntryName(256) As Byte
End Type

Type RASCONN
  dwSize As Long
  hRasConn As Long
  szEntryName(256) As Byte
  szDeviceType(16) As Byte
  szDeviceName(128) As Byte
End Type

Declare Function RasEnumConnectionsA& Lib "rasapi32.dll" _
  (lprasconn As Any, lpcb&, lpcConnections&)
Declare Function RasHangUp Lib "rasapi32.dll" Alias "RasHangUpA" (ByVal hRasConn As Long) As Long
Declare Function RasEnumEntriesA& Lib "rasapi32.dll" _
  (ByVal reserved$, ByVal lpszPhonebook$, lprasentryname As Any, lpcb&, lpcEntries&)


Public Const RASCS_PAUSED = &H1000&
Public Const RASCS_DONE = &H2000&

Public Const RASCS_Connected = RASCS_DONE
Public Const RASCS_Disconnected = RASCS_DONE + 1&

Public Const RAS_MaxDeviceType = 16
Public Const RAS_MaxPhoneNumber = 128
Public Const RAS_MaxIpAddress = 15
Public Const RAS_MaxIpxAddress = 21


Public Const RAS_MaxEntryName = 20
Public Const RAS_MaxDeviceName = 32
Public Const RAS_MaxCallbackNumber = 48

Public Const RAS95_MaxEntryName = 256
Public Const RAS95_MaxDeviceName = 128
Public Const RAS95_MaxCallbackNumber = RAS_MaxPhoneNumber




Public Declare Function RasGetConnectStatus Lib "rasapi32.dll" Alias "RasGetConnectStatusA" (ByVal hRasConn As Long, lpRASCONNSTATUS As Any) As Long

'begin enum
Public Const RASCS_OpenPort = 0&
Public Const RASCS_PortOpened = 1&
Public Const RASCS_ConnectDevice = 2&
Public Const RASCS_DeviceConnected = 3&
Public Const RASCS_AllDevicesConnected = 4&
Public Const RASCS_Authenticate = 5&
Public Const RASCS_AuthNotify = 6&
Public Const RASCS_AuthRetry = 7&
Public Const RASCS_AuthCallback = 8&
Public Const RASCS_AuthChangePassword = 9&
Public Const RASCS_AuthProject = 10&
Public Const RASCS_AuthLinkSpeed = 11&
Public Const RASCS_AuthAck = 12&
Public Const RASCS_ReAuthenticate = 13&
Public Const RASCS_Authenticated = 14&
Public Const RASCS_PrepareForCallback = 15&
Public Const RASCS_WaitForModemReset = 16&
Public Const RASCS_WaitForCallback = 17&
Public Const RASCS_Projected = 18&
 
Public Const RASCS_StartAuthentication = 19&    'Windows 95 only
Public Const RASCS_CallbackComplete = 20&        'Windows 95 only
Public Const RASCS_LogonNetwork = 21&            'Windows 95 only
 
Public Const RASCS_Interactive = RASCS_PAUSED
Public Const RASCS_RetryAuthentication = RASCS_PAUSED + 1&
Public Const RASCS_CallbackSetByCaller = RASCS_PAUSED + 2&
Public Const RASCS_PasswordExpired = RASCS_PAUSED + 3&
 


Public Type RASCONNSTATUS95
    'set dwsize to 160
    dwSize As Long
    rasconnstate As Long                            'RASCONNSTATE Enumeration
    dwError As Long
    szDeviceType(RAS_MaxDeviceType) As Byte
    szDeviceName(RAS95_MaxDeviceName) As Byte
End Type



Public Type RASSTATS2000
        dwSize As Long
        dwBytesXmited As Long
        dwBytesRcved As Long
        dwFramesXmited As Long
        dwFramesRcved As Long
        dwCrcErr As Long
        dwTimeoutErr As Long
        dwAlignmentErr As Long
        dwHardwareOverrunErr As Long
        dwFramingErr As Long
        dwBufferOverrunErr As Long
        dwCompressionRatioIn As Long
        dwCompressionRatioOut As Long
        dwBps As Long
        dwConnectDuration As Long
    End Type

    Declare Function RasGetConnectionStatistics Lib "rasapi32.dll" _
                (ByVal hRasConn As Long, _
                lpStatistics As RASSTATS2000) As Long

    Declare Function RasGetLinkStatistics Lib "rasapi32.dll" _
                (ByVal hRasConn As Long, _
                ByVal dwSubEntry As Long, _
                lpStatistics As RASSTATS2000) As Long
'
'---------------------------------------------------------------------------
'

Function getConnStatus(lnghRasConn) As Long

Dim lngRetcode As Long, lngRASConnState As Long
Dim strDeviceName As String, strDevicetype As String
      
      'using 95
      Dim lprasconnstatus95 As RASCONNSTATUS95
      lprasconnstatus95.dwSize = 160
      lngRetcode = RasGetConnectStatus(lnghRasConn, lprasconnstatus95)
      If lngRetcode Then
         'strDeviceName = "Not Available"
         'strDevicetype = "Not Available"
'         lngRASErrorNumber = lngRetcode
'         strRASDescription = lpRASError.fcnRASErrorString()
'         fcnRASGetConnectionStatus = lngRetcode
      Else
         'success
         lngRASConnState = lprasconnstatus95.rasconnstate
         strDeviceName = nTrim$(StrConv(lprasconnstatus95.szDeviceName(), vbUnicode))
         strDevicetype = nTrim$(StrConv(lprasconnstatus95.szDeviceType(), vbUnicode))
'         fcnRASGetConnectionStatus = 0
      End If
      
      'Debug.Print strDeviceName, strDevicetype, lngRASConnState, lprasconnstatus95.dwError

  getConnStatus = lngRASConnState
  
  #If SimConnect = 1 Then
    getConnStatus = 8192
  #End If
  
End Function



Sub doDisconnect()

Dim lprasconn(255) As RASCONN, lpcConnections As Long, _
  lpcb As Long, hRasConn As Long, NameRasConn As String
lprasconn(0).dwSize = 412
lpcb = 256 * lprasconn(0).dwSize

If RasEnumConnectionsA(lprasconn(0), lpcb, lpcConnections) = 0 Then
  If lpcConnections > 0 Then  ' Eine DF-Netzwerkverbindung ist aktiv
    hRasConn = lprasconn(0).hRasConn  ' Handle der Verbindung
    NameRasConn = StrConv(lprasconn(0).szEntryName, vbUnicode)
    NameRasConn = Left$(NameRasConn, InStr(NameRasConn, vbNullChar) - 1)
    RasHangUp hRasConn
  End If
End If

End Sub


Function GetNT5RASBytesTotal(hRasConn) As Long

  Dim myStats As RASSTATS2000
  Dim rtn As Long
  
  myStats.dwSize = Len(myStats)
  rtn = RasGetConnectionStatistics(hRasConn, myStats)
  
  
  GetNT5RASBytesTotal = myStats.dwBytesRcved + myStats.dwBytesXmited


End Function

Sub listDUNEntries()

Dim s As Long, ln As Long, i As Integer, conname As String
Dim r(255) As RASENTRYNAME95

r(0).dwSize = 264
s = 256 * r(0).dwSize
Call RasEnumEntriesA(vbNullString, vbNullString, r(0), s, ln)

ln = ln - 1   ' ln=Anzahl der vorhandenen DF-Netzwerkverbindungen

frmMain.lstSort.Clear
For i = 0 To ln
  conname = StrConv(r(i).szEntryName(), vbUnicode)
  'MsgBox Left$(conname, InStr(conname, vbNullChar) - 1)
  Call frmMain.lstSort.AddItem(Left$(conname, InStr(conname, vbNullChar) - 1))
Next
  
On Error Resume Next
For i = 1 To 29
  Call Unload(frmMain.mnuProvider(i))
  If Err Then Exit For
Next i
On Error GoTo 0

For i = 0 To ln
  If i > 0 Then Load frmMain.mnuProvider(i)
  frmMain.mnuProvider(i).Caption = frmMain.lstSort.List(i)
  frmMain.mnuProvider(i).Visible = True
  strConn(i) = frmMain.lstSort.List(i)
'  Debug.Print Left$(conname, InStr(conname, vbNullChar) - 1)
Next




End Sub


